<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from parguide.texi on 28 April 1999 -->

<TITLE>The SUIF Parallelizing Compiler Guide - SUIF Features</TITLE>
<link href="parguide_6.html" rel=Next>
<link href="parguide_4.html" rel=Previous>
<link href="parguide_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="parguide_1.html">first</A>, <A HREF="parguide_4.html">previous</A>, <A HREF="parguide_6.html">next</A>, <A HREF="parguide_6.html">last</A> section, <A HREF="parguide_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC5" HREF="parguide_toc.html#TOC5">SUIF Features</A></H2>

<P>
In the SUIF vs. KAP tables (see section <A HREF="parguide_4.html#SEC4">Performance Results</A>), many of the
<EM>SUIF only</EM> loops are due to KAP parallelizing an outer loop while
SUIF is parallelizing an inner loop.  However, in some cases SUIF can
parallelize loops that KAP cannot parallelize.  One reason for this is
that SUIF has stronger dependence analysis.  For example, consider the
following loop from the Perfect Club benchmark SDS.f:

</P>

<PRE>
      DO 200 J = 1, NM1
          JP1 = J + 1
          DO 100 I = JP1, N
              TEMP = A(I,J)
              A(I,J) = A(J,I)
              A(J,I) = TEMP
 100      CONTINUE
 200  CONTINUE
</PRE>

<P>
The SUIF dependence analyzer realizes that since the loop bounds are
triangular, the accesses to <CODE>A(I,J)</CODE> and <CODE>A(J,I)</CODE> are independent.
We are then able to parallelize the outer <CODE>DO 200 J</CODE> loop. 
KAP reports a data dependence, and will only parallelize the 
inner <CODE>DO 100 I</CODE> loop.

</P>
<P>
Another reason that SUIF manages to parallelize loops that KAP misses
is due to reductions.  SUIF's reduction analysis pass will find reductions
over arrays, whereas KAP will only perform reductions over single locations.
For example, consider the following loop (also from SDS.f):

</P>

<PRE>
      DO 20 J = 1, NNPED
          SUMNN = 0.
          DO 10 IQ = 1, NQD
              SUMNN = SUMNN + WTDET(IQ) * N(IQ,I) * N(IQ,J)
 10       CONTINUE

          DO 15 K = 1, 3
              PU(K) = PU(K) + P(K,J) * SUMNN
 15       CONTINUE
 20   CONTINUE
</PRE>

<P>
SUIF parallelizes the outer <CODE>DO 20 J</CODE> by performing a reduction
over the <CODE>PU</CODE> array.  KAP is only able to parallelize the inner
<CODE>DO 15 K</CODE> and <CODE>DO 10 IQ</CODE> loops. 

</P>
<P><HR><P>
<p>Go to the <A HREF="parguide_1.html">first</A>, <A HREF="parguide_4.html">previous</A>, <A HREF="parguide_6.html">next</A>, <A HREF="parguide_6.html">last</A> section, <A HREF="parguide_toc.html">table of contents</A>.
</BODY>
</HTML>
